<?php
namespace Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;

class TaskCrud extends \Generated\Controller\TaskCrud {
	public function save(DTO\Request $request, DTO\Response $response, $showMessage = true) {
        $dataSet     = $request->getDataSet();
        $showMessage = $this->verifyShowMessage($dataSet);
        parent::save($request, $response, $showMessage);
    }

    public function delete(DTO\Request $request, DTO\Response $response, $showMessage = true) {
        $dataSet     = $request->getDataSet();
        $showMessage = $this->verifyShowMessage($dataSet);
        parent::delete($request, $response, $showMessage);
    }

    private function verifyShowMessage($dataSet) {      
        $showMessage = true;

        foreach ($dataSet->getRows() as $row) {
            if(isset($row['isMessage']) && $row['isMessage'] === false) {
                $showMessage = false;
                break;
            }
        }

        return $showMessage;
    }   
}