<?php
/**
 * Created by PhpStorm.
 * User: tuliomagalhaes
 * Date: 22/04/2015
 * Time: 17:15
 */

namespace Service\Calendar\Restriction\Strategy;


use Service\Calendar\TaskCalendar;

class AsLateAsPossible extends  RestrictionStrategyAbstract {


    public function getDatesBeginAndEnd($setAllocation = true)
    {
        if($this->task->needScheduleCalcDates()){
            $endTask = $this->task->getEstimatedBeginDate();
            $taskParent = $this->task->getTreeParent();
            if(!empty($taskParent) && $taskParent->usesDataControl()){
                list($beginTask, $endTaskParent) = $this->taskCalendar->getDatesBeginAndEnd($taskParent,$setAllocation);
                if($endTaskParent > $endTask ){
                    $endTask = clone $endTaskParent;
                }
            }
            $beginTask = $this->taskCalendar->getDateBegin($this->task,$endTask,$setAllocation);
        }else{
            $beginTask = $this->task->getEstimatedBeginDate();
            $endTask = $this->task->getEstimatedEndDate();
        }
        return array($beginTask,$endTask);
    }

    public function getDatesByPrecursor($beginTask,$endTask)
    {
        //do not need treatment
    }

    public function getDatesMinAndMax($dateBeginMax,$dateEndMin)
    {
        return array($dateBeginMax,$dateEndMin);
    }
}