<?php
/**
 * Created by PhpStorm.
 * User: eugeniofonseca
 */

namespace Service;

class Cost {

    protected $costFactory;
    protected $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager, \Factory\Cost $costFactory) {
        $this->costFactory = $costFactory;
        $this->entityManager = $entityManager;
    }

    public function createCost($name, $status, $description) {

        $entity = $this->costFactory->createCost($status, $name, $description);
        $this->entityManager->persist($entity);
        $this->entityManager->flush();
        return $entity;
    }

    public function updateCost($cost, $name, $status, $description) {
     
        $costModel = '\Zeedhi\DevOps\Model\Projectmanagement\Entities\Cost';
        if(!($cost instanceof $costModel)){
            $cost = $this->entityManager->find($costModel, $cost);
        }
        $cost = $this->costFactory->updateCost($cost, $status, $name, $description);
        $this->entityManager->persist($cost);
        $this->entityManager->flush();
        return $cost;
    }

    public function persistCost($cost = null, $name, $status, $description) {
        if(empty($cost)){
            return $this->createCost($name, $status, $description);
        }
        else{
            return $this->updateCost($cost, $name, $status, $description);
        }
    }

}