/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_NATUASSU                                                 */
/* Tabela : NATUASSU                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_NATUASSU' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_NATUASSU
GO

CREATE TRIGGER DTULTATU_NATUASSU
ON NATUASSU
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'NATUASSU', null, 'CDNATUASSU=' + CDNATUASSU + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE NATUASSU
      SET DTULTATUNATU = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(NATUASSU.CDNATUASSU,0)  = ISNULL(INSERTED.CDNATUASSU,0)) AND
            (ISNULL(NATUASSU.NMNATUASSU,0)  = ISNULL(INSERTED.NMNATUASSU,0));
   END;
END;
GO

